//+------------------------------------------------------------------+
//|                                                   mycandle11.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
//|                                                   mycandle10.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_buffers 4
#property indicator_color1 Chartreuse
#property indicator_color2 Tomato
#property indicator_color3 Aqua
#property indicator_color4 Aqua
// ----- indicator_buffers
double   TrendUpBuffer[];
double   TrendDownBuffer[];
double   TrendLineBufferUp[];
double   TrendLineBufferDown[];
//------ input parameters
int      index_up_1,index_up_2,index_down_1,index_down_2;
double   V_up,V_down,Pr_up_Cl_1,Pr_down_Cl_1,Pr_Tr_up_0,Pr_Tr_down_0;
double   TD_up[50],TD_down[50],TDu1,TDu2,TDd1,TDd2,Pr_Tr_down_1,Pr_Tr_up_1;
datetime time_up_1,time_up_2,T_u1,T_u2,T_d1,T_d2,time_down_1,time_down_2;

 string   Time_down_1,Time_down_2,Time_up_1,Time_up_2; 

//+-------------------------------------------------

//----
#define MAGIC 612457
//----
extern int    MAFastPeriod   = 5;
extern int    MASlowPeriod   = 26;
extern int    MASignalPeriod = 9;
extern int    SLOffset       = 0;  // ...adjust SL on last orders to this profit level after TP2 is reached.
extern int    Prots          = 1;
extern int    Prots1         = 2;
extern double lStopLoss      = 100;
extern double sStopLoss      = 100;
extern double TP1            = 300;
extern double TP2            = 500;
extern double lTrailingStop  = 300;
extern double sTrailingStop  = 300;
extern double DecreaseFactor = 100;
extern double MaximumRisk    = 0.1;
extern double MaximumLots    = 100;
extern bool   flag           = true;
//----
double Limit = 400, Lot;
color clOpenBuy = Blue;
color clCloseBuy = Aqua;
color clOpenSell = Red;
color clCloseSell = Violet;
color clModiBuy = Blue;
color clModiSell = Red;
string Name_Expert = "MyCandle";
string lsComm;
int Slippage = 3;

int New_Bar,                                              // 0/1    
    Time_0;                                              //                                                
bool UseSound = True;
string NameFileSound = "alert.wav";
int ticketL1 = -1, // long positions
    ticketL2 = -1,
    ticketS1 = -1, // short positions
    ticketS2 = -1;
double BasePrice=0, BuyPrice, SellPrice;
double buy_sl,
       sell_sl,
       buy_tp1,
       buy_tp2,                          
       sell_tp1,
       sell_tp2,
       MACD1,
       MACD2; 
datetime inittime;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
bool IsOrderOpen(int ticket)
{
   return(OrderSelect(ticket,SELECT_BY_TICKET)
      && (OrderType()==OP_BUY || OrderType()==OP_SELL)
      &&  OrderCloseTime()==0);
}

bool IsOrderClosed(int ticket)
{

   return(!OrderSelect(ticket,SELECT_BY_TICKET) || OrderCloseTime()!=0);
      
}

bool IsLoss(int ticket)
{
   return(OrderSelect(ticket,SELECT_BY_TICKET)
      &&  OrderProfit()<=0
      &&  OrderCloseTime()!=0);
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);        // ,         
   SetIndexArrow(0,236);               //    
   SetIndexBuffer(0,TrendUpBuffer);    //   
   SetIndexEmptyValue(0,0.0);          //     . 
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,238);
   SetIndexBuffer(1,TrendDownBuffer);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_LINE);         
   SetIndexBuffer(2,TrendLineBufferUp);    //   
   SetIndexEmptyValue(2,0.0);           
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,TrendLineBufferDown);  //   
   SetIndexEmptyValue(3,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
    DelObj1();  
    DelObj2();
  return(0);
  }
  void DelObj1()
  {
  ObjectDelete("TrDdown"); //     . 
  }
  void DelObj2()
  {
  ObjectDelete("TrDup");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void deinit2() 
  {
   Comment("");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool HangingManLongWhite100()
  {
   if((Close[1] - Open[1] > 0) && (Open[0] >= Open[1]) && ((Close[1] - Open[1])*2 <= Open[1] - Low[1]) && (High[1] <= Close[1]+0.00030*Point))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool HangingManShortWhite100()
  {
   if(
      (Close[1] - Open[1] > 0) && (Open[0] <= Close[1]) && ((Close[1] - Open[1])*2 <= Open[1] - Low[1]) && (High[1] <= Close[1]+0.00030*Point))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool HangingManLongBlack100()
  {
   if( 
      (Close[1] - Open[1] < 0) && (Open[0] >= Close[1]) && ((Open[1] - Close[1])*2 <= Close[1] - Low[1]) && (High[1] <= Open[1]+0.00030*Point))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool HangingManShortBlack100()
  {
   if((Close[1] - Open[1] < 0) && (Open[0] <= Open[1]) && ((Open[1] - Close[1])*2 <= Close[1] - Low[1]) && (High[1] <= Open[1]+0.00030*Point))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DarkCloudCover100()
  {
   if((Open[2] < Close[2]) && (Close[1] < Open[1]) && (Open[1] >= High[2]) && (Close[1] <=(Close[2] + Open[2]) /2) && (Close[1] < Open[2]))  
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool PiercingPattern100()
  {
   if((Open[2] > Close[2]) && (Close[1] > Open[1]) && (Open[1] <= Low[2]) && (Close[1] >=(Close[2] + Open[2]) /2) && (Close[1] > Open[2]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DarkCloudCover75()
  {
   if((Open[2] < Close[2]) && (Close[1] < Open[1]) && (Open[1] < Close[2]) && (Close[1] <=(Close[2] + Open[2]) /2) && (Close[1] < Open[2])) 
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool PiercingPattern75()
  {
   if((Open[2] > Close[2]) && (Close[1] > Open[1]) && (Open[1] > Close[2]) && (Close[1] >=(Close[2] + Open[2]) /2) && (Close[1] > Open[2]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DojiLong()
  {
   if((Open[1] == Close[1]) && (Open[0] > Low[1]) && (Open[1] - Close[1] || Close[1] - Open[1]) <= 0.00020 && (Close[2] >= Open[1]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DojiShort()
  {
   if((Open[1] == Close[1]) && (Open[0] < High[1]) && (Open[1] - Close[1] || Close[1] - Open[1]) <= 0.00020 && (Close[2] <= Open[1]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DojiStarLong()
  {
   if((Open[1] == Close[1]) && (Open[0] > Low[1]) && (Open[1] - Close[1] || Close[1] - Open[1]) <= 0.00020 && (Close[2] < Open[1]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DojiStarShort()
  {
   if((Open[1] == Close[1]) && (Open[0] < High[1]) && (Open[1] - Close[1] || Close[1] - Open[1]) <= 0.00020 && (Close[2] > Open[1]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool EveningStar()
  {
   if((Open[1] != Close[1]) && (Open[0] > Low[1]) && (Open[1] - Close[1] || Close[1] - Open[1]) <= 0.00020 && (Close[2] < Open[1]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool MorningStar()
  {
   if((Open[1] != Close[1]) && (Open[0] < High[1]) && (Open[1] - Close[1] || Close[1] - Open[1]) <= 0.00020 && (Close[2] > Open[1]))
       return(true);
   else 
       return(false);
  }    
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
bool BullishEngulfingPattern100()
  {
   if((Open[2] > Close[2]) && (Close[1] > Open[1]) && (Close[1] > Open[2]) && (Open[1] <= Close[2]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool BearishEngulfingPattern100()
  {
   if((Open[2] < Close[2]) && (Close[1] < Open[1]) && (Close[1] < Open[2] && Open[1] >= Close[2]))
       return(true);
   else 
       return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {  
  int U=0,D=0;  //      
   //=======================================================================+ 
   for(int i=2;i<24;i++) // 48  - 2-   // i-   
    {
     if(High[i]>High[i+1]&&High[i]>High[i-1]) 
      { 
      if(High[i]>Close[i+2])  
       { 
        U++; //    #1-  #2-  
        if(U==1)
         {
         //        #1  #2
         TD_up[1]=High[i];  
         index_up_1=i;                               //    
         Pr_up_Cl_1=Close[i-1]; //   ,    
         time_up_1=iTime(NULL,0,index_up_1);          //           
         //        
         Time_up_1=TimeToStr(time_up_1,TIME_DATE|TIME_MINUTES);      
          }  
          if(U==2)
           { 
           //        #1  #2
           TD_up[2]=High[i]; 
           index_up_2=i;            //    
           time_up_2=iTime(NULL,0,index_up_2);//          
           Time_up_2=TimeToStr(time_up_2,TIME_DATE|TIME_MINUTES); 
           //    ( TD-    )
           if((U==2 && TD_up[1]<TD_up[2])==false) 
             {    
              U--; TD_up[2]=0.0; if(index_up_2>20) {time_up_1=0;}  continue; 
              }
             else
             { 
              //    TD_max    
              V_up=(TD_up[2]-TD_up[1])/(index_up_2-index_up_1);//(/)
              //   TD   1-   Max
              Pr_Tr_up_1=TD_up[1]-V_up;
              //    1-       
              // TD-   -  ,         
              Pr_Tr_up_0=TD_up[1]-(index_up_1*V_up);           //   "0"  
              //   #3(     
              //    (  )        
              //    TD-)
              if((Pr_up_Cl_1< Pr_Tr_up_1)==false)
               {              
                i=index_up_1+2; TD_up[1]=0.0; TD_up[2]=0.0; time_up_1=0; 
                time_up_2=0; index_up_1=50; index_up_2=50; U=0; 
                TrendDownBuffer[index_up_1]=0.0; continue;
                }
             else
               { //    #3 -           
               //      TD_Down  
                TDu1=TD_up[1];  //   1- 
                T_u1=time_up_1; //  1- 
                TDu2=TD_up[2];  //   2- 
                T_u2=time_up_2; //  2- 
                TrendDownBuffer[index_up_1]=TDu1+5*Point;//    
                //  10       TD-
                for(int k=index_up_2;k<index_up_2+10;k++)
                TrendLineBufferDown[k]=Pr_Tr_up_0+k*V_up;                 
                break;      
                } 
               } 
              } 
             }  
            }
           }
     if(TD_up[2]==0.0) {time_up_1=0; Time_up_1=TimeToStr(time_up_1,TIME_DATE|TIME_MINUTES);}   
//==================================================================================+
   //  Min  ()   
   for(int j=2;j<24;j++) // 48  - 2-   // j-   
    { 
     //   #1 (         ) 
     if(Low[j]<Low[j+1]&&Low[j]<Low[j-1])
      {
       //   #2 (     
       //         <  Min>)
       if(Low[j]<Close[j+2])
        { 
         D++;  //    #1-  #2-  
         if(D==1)
          { 
           TD_down[1]=Low[j]; 
           index_down_1=j;
           Pr_down_Cl_1=Close[j-1]; 
           time_down_1=iTime(NULL,0,j); 
           Time_down_1=TimeToStr(time_down_1,TIME_DATE|TIME_MINUTES);                     
           } 
           if(D==2)
            { 
             TD_down[2]=Low[j]; 
             index_down_2=j; 
             time_down_2=iTime(NULL,0,j);
             Time_down_2=TimeToStr(time_down_2,TIME_DATE|TIME_MINUTES);
             //    ( Min     )
             if((D==2 && TD_down[1]>TD_down[2])==false)
              {
		         D--;   TD_down[2]=0.0;  if(index_down_2>20) {time_down_1=0;}
		         continue; 
		         } 
		        else 
            {             
             //    TD_min    
             V_down=(TD_down[1]-TD_down[2])/(index_down_2-index_down_1);
             //    1-   Min
             Pr_Tr_down_1=TD_down[1]+V_down;
//             } 
             //   #3 (  ()   
             //        
             //   TD-.
             if((Pr_down_Cl_1> Pr_Tr_down_1)==false)
              {
                i=index_down_1+2; TD_down[1]=0.0; TD_down[2]=0.0; time_down_1=0; 
                time_down_2=0; index_down_1=50; index_down_2=50; D=0; continue;
                }
             else
              { //   #3 -   
               TDd1=TD_down[1]; 
               T_d1=time_down_1; 
               TDd2=TD_down[2];  
               T_d2=time_down_2;
               //      "0" 
               Pr_Tr_down_0=TD_down[1]+(index_down_1*V_down); 
               TrendUpBuffer[index_down_1]=TDd2-2*Point; //    
               //  10        
               for(int n=index_down_2;n<index_down_2+10;n++)
                TrendLineBufferUp[n]=Pr_Tr_down_0-n*V_down;
               break;                   
               } 
              } 
             } 
            }
           } 
          }  
     if(TD_down[2]==0.0) {time_down_1=0; Time_down_1=TimeToStr(time_down_1,TIME_DATE|TIME_MINUTES);} 
// ----------------------------------------------------------------------------+
//        
// ----------------------------------------------------------------------------+
    if(TDu2==0.0) {time_down_1=0; TrendDownBuffer[index_down_1]=0.0;}
     else
    {    
       DelObj1(); //     
	    ObjectCreate("TrDdown",OBJ_TREND,0,T_u2,TDu2,T_u1,TDu1); 
     if(time_up_1<time_down_1) 
      {           //    :
       ObjectSet("TrDdown",OBJPROP_COLOR,DeepPink);
       ObjectSet("TrDdown",OBJPROP_WIDTH,1);  //    
       ObjectSet("TrDdown",OBJPROP_STYLE,STYLE_DOT);// 
       }
      else
       {                //     :
        ObjectSet("TrDdown",OBJPROP_COLOR,DeepPink);
        ObjectSet("TrDdown",OBJPROP_WIDTH,1);           //  
        ObjectSet("TrDdown",OBJPROP_STYLE,STYLE_SOLID); //  
       }
      }
// -----------------------------
    if(TDd2==0.0) {time_up_1=0;  TrendUpBuffer[index_up_1]=0.0;}
      else
      {
        DelObj2(); //  ,   
	     ObjectCreate("TrDup",OBJ_TREND,0,T_d2,TDd2,T_d1,TDd1);
//////	     TrendDownBuffer[index_down_1]=0.0; 
	   if(time_down_1<time_up_1)
	    {   
	     ObjectSet("TrDup",OBJPROP_COLOR,Yellow); 
	     ObjectSet("TrDup",OBJPROP_WIDTH,1); 
        ObjectSet("TrDup",OBJPROP_STYLE,STYLE_DOT);
        }
		 else
		  {
		  ObjectSet("TrDup",OBJPROP_COLOR,Lime); 
		  ObjectSet("TrDup",OBJPROP_WIDTH,2);  
		  ObjectSet("TrDup",OBJPROP_STYLE,STYLE_SOLID);
		  }
		 }
// ----------------------------------------------------------------------------+
// ----------------------------------------------------------------------------+
// ----------------------------------------------------------------------------+   
   if(Bars < 100)
     {  
       return(0);
     }
    if(!IsOrderOpen(ticketL1)) 
         if(IsOrderOpen(ticketL2))
            if(Bid-OrderOpenPrice() >= TP1*Point && OrderStopLoss() < OrderOpenPrice()+SLOffset*Point)
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+SLOffset*Point,OrderTakeProfit(),OrderExpiration());
  
   if(!IsOrderOpen(ticketS1))
         if(IsOrderOpen(ticketS2))
            if(OrderOpenPrice()-Ask > TP1*Point && OrderStopLoss() > OrderOpenPrice()-SLOffset*Point)
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-SLOffset*Point,OrderTakeProfit(),OrderExpiration());
 
          New_Bar=0;                                     //   
   if (Time_0 != Time[0])                                //      
      {
      New_Bar= 1;                                        //     
      Time_0 = Time[0];                                  //     
      } 
       if(BullishEngulfingPattern100() == true && New_Bar == 1 && (D==2 && TD_down[1]>TD_down[2])==true)
         {
           OpenBuy();
           Comment("BullishEngulfingPattern100");
           return(0);
         }
       if(BearishEngulfingPattern100() == true && New_Bar == 1 && (U==2 && TD_up[1]<TD_up[2])==true)
         {
           OpenSell();
           Comment("BearishEngulfingPattern100");
           return(0);
         }
       if(HangingManLongWhite100() == true && New_Bar == 1 && (D==2 && TD_down[1]>TD_down[2])==true)
         {
           OpenBuy();
           Comment("HangingManLongWhite100");
           return(0);
         } 
       if(HangingManShortWhite100() == true && New_Bar == 1 && (U==2 && TD_up[1]<TD_up[2])==true)
         {
           OpenSell();
           Comment("HangingManShortWhite100");
           return(0);
         }
       if(HangingManLongBlack100() == true && New_Bar == 1 && (D==2 && TD_down[1]>TD_down[2])==true)
         {
           OpenBuy();
           Comment("HangingManLongBlack100");
           return(0);
         }
       if(HangingManShortBlack100() == true && New_Bar == 1 && (U==2 && TD_up[1]<TD_up[2])==true)
         {
           OpenSell();
           Comment("HangingManShortBlack100");
           return(0);
         } 
       if(DarkCloudCover100() == true && New_Bar == 1 && (U==2 && TD_up[1]<TD_up[2])==true)
         {
           OpenSell();
           Comment("DarkCloudCover100");
           return(0);
         }
       if(PiercingPattern100() == true && New_Bar == 1 && (D==2 && TD_down[1]>TD_down[2])==true)
         {
           OpenBuy();
           Comment("PiercingPattern100");
           return(0);
         }     
       if(DarkCloudCover75() == true && New_Bar == 1 && (U==2 && TD_up[1]<TD_up[2])==true)
         {
           OpenSell();
           Comment("DarkCloudCover100");
           return(0);
         }
       if(PiercingPattern75() == true && New_Bar == 1 && (D==2 && TD_down[1]>TD_down[2])==true)
         {
           OpenBuy();
           Comment("PiercingPattern100");
           return(0);
         }  
       if(DojiLong() == true && New_Bar == 1 && (D==2 && TD_down[1]>TD_down[2])==true)
         {
           OpenBuy();
           Comment("DojiLong");
           return(0);
         }
       if(DojiShort() == true && New_Bar == 1 && (U==2 && TD_up[1]<TD_up[2])==true)
         {
           OpenSell();
           Comment("DojiShort");
           return(0);
         } 
       if(EveningStar() == true && New_Bar == 1 && (U==2 && TD_up[1]<TD_up[2])==true)
         {
           OpenSell();
           Comment("DarkCloudCover100");
           return(0);
         }
       if(MorningStar() == true && New_Bar == 1 && (D==2 && TD_down[1]>TD_down[2])==true)
         {
           OpenBuy();
           Comment("PiercingPattern100");
           return(0);
         }  
       if(DojiStarLong() == true && New_Bar == 1 && (D==2 && TD_down[1]>TD_down[2])==true)
         {
           OpenBuy();
           Comment("DojiLong");
           return(0);
         }
       if(DojiStarShort() == true && New_Bar == 1 && (U==2 && TD_up[1]<TD_up[2])==true)
         {
           OpenSell();
           Comment("DojiShort");
           return(0);
         }   
   return (0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OpenBuy() 
  { 
   ticketL1 = OrderSend(Symbol(),OP_BUY,Lots1(),Ask,Slippage,Buystop(),Ask+TP1 *Point, "", MAGIC, 0, Blue);

   ticketL2 = OrderSend(Symbol(),OP_BUY,Lots(),Ask,Slippage,Buystop(),Ask+TP2 *Point, "", MAGIC, 0, Blue);        
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OpenSell() 
  {  
   ticketS1 = OrderSend(Symbol(),OP_SELL,Lots1(),Bid,Slippage,Sellstop(),Bid-TP1 *Point, "", MAGIC, 0, Red);

   ticketS2 = OrderSend(Symbol(),OP_SELL,Lots(),Bid,Slippage,Sellstop(),Bid-TP2 *Point, "", MAGIC, 0, Red);     
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetCommentForOrder() 
  { 	
    return(Name_Expert); 
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Buystop() 
  { 	
    if (Low[1] < Low[2] && Low[1] < Low[3])	
       return(Low[1] - sStopLoss*Point);
    if (Low[2] < Low[1] && Low[2] < Low[3])
       return(Low[2] - sStopLoss*Point);
    else return (Low[3] - sStopLoss*Point); 
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Sellstop() 
  { 
    if (High[1] > High[2] && High[1] > High[3])	
       return(High[1] + sStopLoss*Point);
    if (High[2] > High[1] && High[2] > High[3])
       return(High[2] + sStopLoss*Point);
    else return (High[3] + sStopLoss*Point);    
  } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Lots()                                            //  
     {
       Lot=NormalizeDouble(AccountFreeMargin()*Prots/100/1000,1);//  .   
       double Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);   //   . 
       if (Lot == 0 ) Lot = Min_Lot;                         //    . . 
//============================================================================================
          return(Lot);
     }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Lots1()                                            //  
     {
       Lot=NormalizeDouble(AccountFreeMargin()*Prots1/100/1000,1);//  .   
       double Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);   //   . 
       if (Lot == 0 ) Lot = Min_Lot;                         //    . . 
//============================================================================================
          return(Lot);
     }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+